/* screensave.c
 * TiVo "screensaver"
 * 2002, embeem <mbm@linux.com>
 *
 * GPL'd
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

int fd;
int last;
int paused;
int timeout=300;

int  led=0;
char pwr_on=0x50;
char pwr_off=0x60;

int main(int argc, char **argv) {
  while (1) {
    int arg;
    if (-1 == (arg = getopt(argc, argv, "t:"))) break;
    switch (arg) {
    case 't':
      timeout=atoi(optarg)*10;
      break;
    }
  }
  fd = open("/dev/mpeg0o",O_RDONLY);
  while (1) {
    int current;
    usleep(100000);
    current = ioctl(fd,0x3fd)/9090;
    if (current == last) {
      if (paused > 0) {
	paused--;
      } else if (!paused) {
	ioctl(fd,0x3f4); //osd off
	ioctl(fd,0x41B); //black
	paused=-1;
      } else /* paused==-1 */ {
        if (++led == 10) {
           led = open("/dev/ttyS0",O_WRONLY);
           write(led, &pwr_off, 1);
           close(led); led=10;
        } else if (led == 20) {
           led = open("/dev/ttyS0",O_WRONLY);
           write(led, &pwr_on, 1);
           close(led); led=0;
        }
      }
    } else {
      if (paused==-1) {
	ioctl(fd,0x41C); //unblack
	ioctl(fd,0x3f3); //osd on
        led = open("/dev/ttyS0",O_WRONLY);
        write(led, &pwr_on, 1);
        close(led); 
      }
      paused=timeout;
      last=current;
    }
  }
  return 0;
}
